#ifdef __LP64__
#define BIT_SHIFT_ 6
#define BIT_MASK_ 0x3f
#else
#define BIT_SHIFT_ 5
#define BIT_MASK_ 0x1f
#endif

static inline int set_bit(int nr,long * addr)
{
	int mask, retval;

	addr += nr >> BIT_SHIFT_;
	mask = 1 << (nr & BIT_MASK_);
	retval = (mask & *addr) != 0;
	*addr |= mask;
	return retval;
}

static inline int clear_bit(int nr, long * addr)
{
	int mask, retval;

	addr += nr >> BIT_SHIFT_;
	mask = 1 << (nr & BIT_MASK_);
	retval = (mask & *addr) != 0;
	*addr &= ~mask;
	return retval;
}

static inline int test_bit(int nr, long * addr)
{
	int mask;

	addr += nr >> BIT_SHIFT_;
	mask = 1 << (nr & BIT_MASK_);
	return ((mask & *addr) != 0);
}

#undef BIT_SHIFT_
#undef BIT_MASK_
